class Cellule:

    def __init__(self, valeur, suivant):
        self._valeur = valeur
        self._suivant = suivant

class Liste:
    
    def __init__(self, c):
        self.cellule = c
            
    def valeur(self):
        return self.cellule._valeur
    
    def suite(self):
        return Liste(self.cellule._suivant)
    
    def est_vide(self):
        return self.cellule == None

    def ajoute(self, valeur):
        self.cellule = Cellule(valeur, self.cellule)
        
    def __repr__(self):
        if self.est_vide():
            return "[]"
        suivant = self.suite()
        valeur = self.valeur()
        res = "[" + str(valeur) + ", "
        while not suivant.est_vide():
            res = res + str(suivant.valeur()) + ", "
            suivant = suivant.suite()
        return res[:-2] + "]"
   
def liste_vide():
    return Liste(None)

class Pile:
    
    def __init__(self, c):
        self.cellule = c
            
    def empiler(self, valeur):
        self.cellule = Cellule(valeur, self.cellule)
      
    def depiler(self):
        valeur = self.cellule._valeur
        self.cellule = self.cellule._suivant
        return valeur
          
    def est_vide(self):
        return self.cellule == None

def pile_vide():
    return Pile(None)

class File:
    
    def __init__(self, c):
        self.cellule = c
            
    def enfiler(self, valeur):
        if self.est_vide():
            self.cellule = Cellule(valeur, self.cellule)
        else:
            cel = self.cellule
            while cel._suivant != None:
                cel = cel._suivant
            cel._suivant = Cellule(valeur, cel._suivant)
        
    def defiler(self):
        valeur = self.cellule._valeur
        self.cellule = self.cellule._suivant
        return valeur
          
    def est_vide(self):
        return self.cellule == None
   
def file_vide():
    return File(None)
        
"""
Fonctions associées aux méthodes pour assurer la comptabilité des codes
"""

def valeur(liste):
    return liste.valeur()
def suite(liste):
    return liste.suite()
def ajoute(liste, valeur):
    liste.ajoute(valeur)
def empiler(pile, valeur):
    pile.empiler(valeur)
def depiler(pile):
    return pile.depiler()
def enfiler(file, valeur):
    file.enfiler(valeur)
def defiler(file):
    return file.defiler()
def est_vide(listepilefile):
    return listepilefile.est_vide()



